## snapd 2.68.3

=== debian/changelog ===
snapd (2.68.3-3) unstable; urgency=medium

  [ Zygmunt Krynicki ]
  * Include libc-dev-bin in Built-Using
  * Remove Luke Faraone from uploaders
  * Regenerate multilib patch
  * Patch spread.yaml to allow testing on trixie

  [ Helmut Grohne ]
  * Stop using gcc-multilib and fix snap-seccomp test.

 -- Zygmunt Krynicki <me@zygoon.pl>  Tue, 15 Jul 2025 06:01:41 +0000

snapd (2.68.3-2) unstable; urgency=medium

  * switch to pkgconf
  * remove checks related to snap-repair

 -- Zygmunt Krynicki <me@zygoon.pl>  Tue, 25 Mar 2025 12:33:00 +0000

snapd (2.68.3-1) unstable; urgency=medium

  [ Ernest Lotter ]
  * New upstream release, LP: #2098137
    - FDE: LP: #2101834 snapd 2.68+ and snap-bootstrap <2.68 fallback to
      old keyring path
    - Fix Plucky snapd deb build issue related to /var/lib/snapd/void
      permissions
    - Fix snapd deb build complaint about ifneq with extra bracket

  [ Zygmunt Krynicki ]
  * migrate to debhelper-compat
  * build only specific binaries
  * expand dh-golang hack to secboot/keys

 -- Zygmunt Krynicki <me@zygoon.pl>  Tue, 25 Mar 2025 11:44:06 +0000

snapd (2.68.2-1) unstable; urgency=medium

  * New upstream release, LP: #2098137
    - FDE: use boot mode for FDE hooks
    - FDE: add snap-bootstrap compatibility check to prevent image
      creation with incompatible snapd and kernel snap
    - FDE: add argon2 out-of-process KDF support
    - FDE: have separate mutex for the sections writing a fresh modeenv
    - FDE: LP: #2099709 update secboot to e07f4ae48e98
    - Confdb: support pruning ephemeral data and process alternative
      types in order
    - core-initrd: look at env to mount directly to /sysroot
    - core-initrd: prepare for Plucky build and split out 24.10
      (Oracular)
    - Fix missing primed packages in snapd snap manifest
    - Interfaces: posix-mq | fix incorrect clobbering of global variable
      and make interface more precise
    - Interfaces: opengl | add more kernel fusion driver files

 -- Ernest Lotter <ernest.lotter@canonical.com>  Thu, 27 Feb 2025 09:56:20 +0200

snapd (2.68.1-1) unstable; urgency=medium

  * New upstream release, LP: #2098137
    - Fix snap-confine type specifier type mismatch on armhf

 -- Ernest Lotter <ernest.lotter@canonical.com>  Mon, 24 Feb 2025 10:31:49 +0200

snapd (2.68-1) unstable; urgency=medium

  * New upstream release, LP: #2098137
    - FDE: add support for new and more extensible key format that is
      unified between TPM and FDE hook
    - FDE: add support for adding passphrases during installation
    - FDE: update secboot to 30317622bbbc
    - Snap components: make kernel components available on firstboot
      after either initramfs or ephemeral rootfs style install
    - Snap components: mount drivers tree from initramfs so kernel
      modules are available in early boot stages
    - Snap components: support remodeling to models that contain
      components
    - Snap components: support offline remodeling to models that contain
      components
    - Snap components: support creating new recovery systems with
      components
    - Snap components: support downloading components with 'snap
      download' command
    - Snap components: support sideloading asserted components
    - AppArmor Prompting(experimental): improve version checks and
      handling of listener notification protocol for communication with
      kernel AppArmor
    - AppArmor Prompting(experimental): make prompt replies idempotent,
      and have at most one rule for any given path pattern, with
      potentially mixed outcomes and lifespans
    - AppArmor Prompting(experimental): timeout unresolved prompts after
      a period of client inactivity
    - AppArmor Prompting(experimental): return an error if a patch
      request to the API would result in a rule without any permissions
    - AppArmor Prompting(experimental): warn if there is no prompting
      client present but prompting is enabled, or if a prompting-related
      error occurs during snapd startup
    - AppArmor Prompting(experimental): do not log error when converting
      empty permissions to AppArmor permissions
    - Confdb(experimental): rename registries to confdbs (including API
      /v2/registries => /v2/confdb)
    - Confdb(experimental): support marking confdb schemas as ephemeral
    - Confdb(experimental): add confdb-control assertion and feature
      flag
    - Refresh App Awareness(experimental): LP: #2089195 prevent
      possibility of incorrect notification that snap will quit and
      update
    - Confidential VMs: snap-bootstrap support for loading partition
      information from a manifest file for cloudimg-rootfs mode
    - Confidential VMs: snap-bootstrap support for setting up cloudimg-
      rootfs as an overlayfs with integrity protection
    - dm-verity for essential snaps: add support for snap-integrity
      assertion
    - Interfaces: modify AppArmor template to allow owner read on
      @{PROC}/@{pid}/fdinfo/*
    - Interfaces: LP: #2072987 modify AppArmor template to allow using
      setpriv to run daemon as non-root user
    - Interfaces: add configfiles backend that ensures the state of
      configuration files in the filesystem
    - Interfaces: add ldconfig backend that exposes libraries coming
      from snaps to either the rootfs or to other snaps
    - Interfaces: LP: #1712808 LP: 1865503 disable udev backend when
      inside a container
    - Interfaces: add auditd-support interface that grants audit_control
      capability and required paths for auditd to function
    - Interfaces: add checkbox-support interface that allows
      unrestricted access to all devices
    - Interfaces: fwupd | allow access to dell bios recovery
    - Interfaces: fwupd | allow access to shim and fallback shim
    - Interfaces: mount-control | add mount option validator to detect
      mount option conflicts early
    - Interfaces: cpu-control | add read access to /sys/kernel/irq/


=== debian/control ===
Source: snapd
Section: devel
Priority: optional
Maintainer: Michael Hudson-Doyle <mwhudson@debian.org>
Uploaders: Zygmunt Krynicki <me@zygoon.pl>,
           Michael Vogt <mvo@debian.org>
Build-Depends: debhelper (>= 13),
               debhelper-compat (= 13),
               dh-apparmor,
               dh-golang (>=1.7),
               autoconf,
               autoconf-archive,
               automake,
               bash-completion,
               ca-certificates,
               dbus,
               fakeroot,
               gcc-i686-linux-gnu [amd64] <!nocheck>,
               libc6-dev-i386-cross [amd64] <!nocheck>,
               gettext,
               gnupg2,
               golang-dbus-dev,
               golang-github-bmatcuk-doublestar-dev,
               golang-github-coreos-bbolt-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-gorilla-mux-dev,
               golang-github-jessevdk-go-flags-dev,
               golang-github-juju-ratelimit-dev,
               golang-github-kr-pretty-dev,
               golang-github-mvo5-goconfigparser-dev,
               golang-github-seccomp-libseccomp-golang-dev,
               golang-go (>=2:1.18),
               golang-golang-x-crypto-dev,
               golang-golang-x-xerrors-dev,
               golang-gopkg-check.v1-dev,
               golang-gopkg-macaroon.v1-dev,
               golang-gopkg-mgo.v2-dev,
               golang-gopkg-retry.v1-dev,
               golang-gopkg-tomb.v2-dev (>= 0.0~git20161208.0.d5d1b58),
               golang-gopkg-tylerb-graceful.v1-dev,
               golang-gopkg-yaml.v2-dev,
               golang-gopkg-yaml.v3-dev,
               grub-common,
               indent,
               libapparmor-dev,
               libcap-dev,
               libglib2.0-dev,
               liblzo2-dev,
               libseccomp-dev,
               libudev-dev,
               openssh-client,
               pkgconf,
               python3,
               python3-docutils,
               python3-markdown,
               squashfs-tools,
               systemd-dev,
               tzdata,
               udev,
               xfslibs-dev
Standards-Version: 4.6.0
Homepage: https://github.com/snapcore/snapd
Vcs-Browser: https://salsa.debian.org/debian/snapd
Vcs-Git: https://salsa.debian.org/debian/snapd.git
XS-Go-Import-Path: github.com/snapcore/snapd

Package: golang-github-snapcore-snapd-dev
Architecture: all
Breaks: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
        golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Replaces: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
          golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Depends: ${misc:Depends}
Description: snappy development go packages.
 Use these to use the snappy API.

Package: snapd
Architecture: any
Depends: adduser,
         apparmor (>= 2.10.95-5),
         ca-certificates,
         default-dbus-session-bus | dbus-session-bus,
         gnupg1 | gnupg,
         kmod,
         openssh-client,
         squashfs-tools,
         systemd,
         udev,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: snap-confine (<< 2.23),
          snapd-xdg-open (<= 0.0.0),
          ubuntu-core-launcher (<< 2.22),
          ubuntu-snappy (<< 1.9),
          ubuntu-snappy-cli (<< 1.9)
Breaks: snap-confine (<< 2.23),
        snapd-xdg-open (<= 0.0.0),
        ubuntu-core-launcher (<< 2.22),
        ubuntu-snappy (<< 1.9),
        ubuntu-snappy-cli (<< 1.9),
        ${snapd:Breaks}
Recommends: gnupg
Suggests: zenity | kdialog
Conflicts: snap (<< 2013-11-29-1ubuntu1)
Built-Using: ${Built-Using} ${misc:Built-Using}
Description: Daemon and tooling that enable snap packages
 Install, configure, refresh and remove snap packages. Snaps are
 'universal' packages that work across many different Linux systems,
 enabling secure distribution of the latest apps and utilities for
 cloud, servers, desktops and the internet of things.
 .
 Start with 'snap list' to see installed snaps.

Package: snap-confine
Architecture: any
Section: oldlibs
Depends: snapd (= ${binary:Version}), ${misc:Depends}
Description: Transitional package for snapd
 This is a transitional dummy package. It can safely be removed.

Package: ubuntu-core-launcher
Architecture: any
Depends: snapd (= ${binary:Version}), ${misc:Depends}
Section: oldlibs
Pre-Depends: dpkg (>= 1.15.7.2)
Description: Transitional package for snapd
 This is a transitional dummy package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# These rules should work for any debian-ish distro that uses systemd
# as init.  That does _not_ include Ubuntu 14.04 ("trusty"); look for
# its own special rule file.
#
# Please keep the diff between that and this relatively small, even if
# it means having suboptimal code; these need to be kept in sync by
# sentient bags of meat.

#export DH_VERBOSE=1
export DH_OPTIONS
export DH_GOPKG := github.com/snapcore/snapd
#export DEB_BUILD_OPTIONS=nocheck
export DH_GOLANG_EXCLUDES=tests
export DH_GOLANG_BUILDPKG = $(strip $(addprefix $(DH_GOPKG)/, \
    cmd/snap \
    cmd/snap-exec \
    cmd/snap-seccomp \
    cmd/snap-update-ns \
    cmd/snapctl \
    cmd/snapd \
    cmd/snapd-apparmor \
    ))
# skip Go generate, all source code should have been committed
export DH_GOLANG_GO_GENERATE=0

export PATH:=${PATH}:${CURDIR}
# GOCACHE is needed by go-1.13+
export GOCACHE:=/tmp/go-build

include /etc/os-release

# On 18.04 the released version of apt (1.6.1) has a bug that causes
# problem on "apt purge snapd". To ensure this won't happen add the
# right dependency on 18.04.
ifeq (${VERSION_ID},"18.04")
	SUBSTVARS = -Vsnapd:Breaks="apt (<< 1.6.3)"
endif
# Same as above for 18.10 just a different version.
ifeq (${VERSION_ID},"18.10")
	SUBSTVARS = -Vsnapd:Breaks="apt (<< 1.7.0~alpha2)"
endif

# this is overridden in the ubuntu/14.04 release branch
SYSTEMD_UNITS_DESTDIR="$(shell pkg-config --variable=systemdsystemunitdir systemd)"

# The go tool does not fully support vendoring with gccgo, but we can
# work around that by constructing the appropriate -I flag by hand.
GCCGO := $(shell go tool dist env > /dev/null 2>&1 && echo no || echo yes)

# Disable -buildmode=pie mode on i386 as can panics in spectacular
# ways (LP: #1711052).
# See also https://forum.snapcraft.io/t/artful-i386-panics/
# Note while the panic is only on artful, that's because artful
# detects it; the issue potentially there on older things.
BUILDFLAGS:=-pkgdir=$(CURDIR)/_build/std
ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
BUILDFLAGS+= -buildmode=pie
endif

GCCGOFLAGS=
ifeq ($(GCCGO),yes)
GOARCH := $(shell go env GOARCH)
GOOS := $(shell go env GOOS)
BUILDFLAGS:=
GCCGOFLAGS=-gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
export DH_GOLANG_GO_GENERATE=0
# workaround for https://github.com/golang/go/issues/23721
export GOMAXPROCS=2
endif

# check if we need to include the testkeys in the binary
# TAGS are the go build tags for all binaries, SNAP_TAGS are for snap
# build only.
TAGS=nosecboot
SNAP_TAGS=nosecboot nomanagers
ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
	TAGS+= withtestkeys
	SNAP_TAGS+= withtestkeys
endif

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# /usr/lib/snapd/snap-{update-ns,gdbserver-shim,gdb-shim} are always linked
# statically against glibc. Use libc-dev-bin to avoid having to handle the
# different soname (e.g. libc6 vs libc6.1)
BUILT_USING_PACKAGES=libc-dev-bin

# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Currently, we enable confinement for Ubuntu only, not for derivatives,
# because derivatives may have different kernels that don't support all the
# required confinement features and we don't to mislead anyone about the
# security of the system.  Discuss a proper approach to this for downstreams
# if and when they approach us.
ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
    # On Ubuntu 16.04 we need to produce a build that can be used on wide
    # variety of systems. As such we prefer static linking over dynamic linking
    # for stability, predicability and easy of deployment. We need to link some
    # things dynamically though: udev has no stable IPC protocol between
    # libudev and udevd so we need to link with it dynamically.
    VENDOR_ARGS=--enable-nvidia-multiarch --enable-static-libcap --enable-static-libapparmor --enable-static-libseccomp --with-host-arch-triplet=$(DEB_HOST_MULTIARCH)
ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),amd64)
		VENDOR_ARGS+= --with-host-arch-32bit-triplet=$(shell dpkg-architecture -f -ai386 -qDEB_HOST_MULTIARCH)
endif
    BUILT_USING_PACKAGES+=libcap-dev libapparmor-dev libseccomp-dev
else
ifeq ($(shell dpkg-vendor --query Vendor),Debian)
    VENDOR_ARGS=--enable-nvidia-multiarch
    BUILT_USING_PACKAGES+=libcap-dev
else
    VENDOR_ARGS=--disable-apparmor
endif
endif
BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(BUILT_USING_PACKAGES))

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_fixperms:
	dh_fixperms -Xusr/lib/snapd/snap-confine


# The .real profile is a workaround for a bug in dpkg LP: #1673247 that causes
# ubiquity to crash. It allows us to "move" the snap-confine profile from
# snap-confine into snapd in a way that works with old dpkg that is in the live
# CD image.
#
# Because both the usual and the .real profile describe the same binary the
# .real profile takes priority (as it is loaded later).
override_dh_installdeb:
	dh_apparmor --profile-name=usr.lib.snapd.snap-confine.real -psnapd
	dh_installdeb

override_dh_clean:
	dh_clean
	$(MAKE) -C data clean
	# XXX: hacky
	$(MAKE) -C cmd distclean || true

override_dh_auto_build:
	# usually done via `go generate` but that is not supported on powerpc
	GO_GENERATE_BUILDDIR=_build/src/$(DH_GOPKG) GO111MODULE=off GOPATH=$$(pwd)/_build ./mkversion.sh
	# Build golang bits
	mkdir -p _build/src/$(DH_GOPKG)/cmd/snap/test-data
	cp -a cmd/snap/test-data/*.gpg _build/src/$(DH_GOPKG)/cmd/snap/test-data/
	cp -a bootloader/assets/data _build/src/$(DH_GOPKG)/bootloader/assets

	# exclude certain parts that won't be used by debian
	find _build/src/$(DH_GOPKG)/cmd/snap-bootstrap -name "*.go" | xargs rm -f
	find _build/src/$(DH_GOPKG)/cmd/snap-fde-keymgr -name "*.go" | xargs rm -f
	find _build/src/$(DH_GOPKG)/gadget/install -name "*.go" | grep -vE '(params\.go|install_dummy\.go|kernel\.go)'| xargs rm -f
	# XXX: once dh-golang understands go build tags this would not be needed
	find _build/src/$(DH_GOPKG)/secboot/ -name "*.go" | grep -E '(.*_sb(_test)?\.go|.*_tpm(_test)?\.go|secboot_hooks.go|keymgr/)' | xargs rm -f
	mv _build/src/$(DH_GOPKG)/secboot/keys/plainkey.go _build/src/$(DH_GOPKG)/secboot/keys/plainkey_sb.go
	mv _build/src/$(DH_GOPKG)/secboot/keys/plainkey_test.go _build/src/$(DH_GOPKG)/secboot/keys/plainkey_sb_test.go
	find _build/src/$(DH_GOPKG)/secboot/keys/ -name "*.go" | grep -E '(.*_sb(_test)?\.go)' | xargs rm -f
	find _build/src/$(DH_GOPKG)/boot/ -name "*.go" | grep -E '(.*_sb(_test)?\.go)' | xargs rm -f
	# and build, we cannot use modules as packaging on Debian requires us to use
	# dependencies from the distro, and this would require further updates to the
	# go.mod file
	GO111MODULE=off dh_auto_build -- $(BUILDFLAGS) -tags "$(TAGS)" $(GCCGOFLAGS)

	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. go build $(BUILDFLAGS) $(GCCGOFLAGS) -tags "$(SNAP_TAGS)" $(DH_GOPKG)/cmd/snap)

	# (static linking on powerpc with cgo is broken)
ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),powerpc)
	# Generate static snap-exec, snapctl and snap-update-ns - it somehow includes CGO so
	# we must force a static build here. We need a static snap-{exec,update-ns}
	# inside the core snap because not all bases will have a libc
	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. CGO_ENABLED=0 go build -tags "$(TAGS)" $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snap-exec)
	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. CGO_ENABLED=0 go build -tags "$(TAGS)" $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snapctl)
	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. go build -tags "$(TAGS)" --ldflags '-extldflags "-static"' $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snap-update-ns)

	# ensure we generated a static build
	$(shell	if ldd _build/bin/snap-exec; then false "need static build"; fi)

## snapd 2.71

=== data/polkit/Makefile ===
#
# Copyright (C) 2024 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

DATADIR = /usr/share
POLKITACTIONSDIR := $(DATADIR)/polkit-1/actions

POLKIT_ACTIONS = $(wildcard *.policy)

.PHONY: all
all: $(POLKIT_ACTIONS)

.PHONY: install
install: $(POLKIT_ACTIONS)
	install -d -m 0755 $(DESTDIR)/$(POLKITACTIONSDIR)
	install -m 0644 -t $(DESTDIR)/$(POLKITACTIONSDIR) $^

.PHONY: clean
clean:
	echo "Nothing to see here."

=== data/systemd-user/Makefile ===
#
# Copyright (C) 2019 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

SNAPD_ENVIRONMENT_FILE := /etc/environment
BINDIR := /usr/bin
SYSTEMDUSERUNITDIR := /usr/lib/systemd/user

SYSTEMD_UNITS_GENERATED := $(wildcard *.in)
# NOTE: sort removes duplicates so this gives us all the units, generated or otherwise
SYSTEMD_UNITS = $(sort $(SYSTEMD_UNITS_GENERATED:.in=) $(wildcard *.service) $(wildcard *.timer) $(wildcard *.socket))

.PHONY: all
all: $(SYSTEMD_UNITS)

.PHONY: install
install:: $(SYSTEMD_UNITS)
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 $(DESTDIR)/$(SYSTEMDUSERUNITDIR)
	install -m 0644 -t $(DESTDIR)/$(SYSTEMDUSERUNITDIR) $^

.PHONY: clean
clean:
	rm -f $(SYSTEMD_UNITS_GENERATED:.in=)

%: %.in
	cat $< | \
		sed s:@bindir@:$(BINDIR):g | \
		cat > $@

=== debian/changelog ===
snapd (2.71-3) unstable; urgency=medium

  * Set nooptee build tag to disable OP-TEE support

 -- Zygmunt Krynicki <me@zygoon.pl>  Thu, 21 Aug 2025 20:46:02 +0000

snapd (2.71-2) unstable; urgency=medium

  * Cherry pick a fix for unit test
  * Depend on libcap2-bin for setcap

 -- Zygmunt Krynicki <me@zygoon.pl>  Thu, 21 Aug 2025 19:08:54 +0000

snapd (2.71-1) unstable; urgency=medium

  [ Ernest Lotter ]
  * New upstream release, LP: #2118396
    - FDE: auto-repair when recovery key is used
    - FDE: revoke keys on shim update
    - FDE: revoke old TPM keys when dbx has been updated
    - FDE: do not reseal FDE hook keys every time
    - FDE: store keys in the kernel keyring when installing from initrd
    - FDE: allow disabled DMA on Core
    - FDE: snap-bootstrap: do not check for partition in scan-disk on
      CVM
    - FDE: support secboot preinstall check for 25.10+ hybrid installs
      via the /v2/system/{label} endpoint
    - FDE: support generating recovery key at install time via the
      /v2/systems/{label} endpoint
    - FDE: update passphrase quality check at install time via the
      /v2/systems/{label} endpoint
    - FDE: support replacing recovery key at runtime via the new
      /v2/system-volumes endpoint
    - FDE: support checking recovery keys at runtime via the /v2/system-
      volumes endpoint
    - FDE: support enumerating keyslots at runtime via the /v2/system-
      volumes endpoint
    - FDE: support changing passphrase at runtime via the /v2/system-
      volumes endpoint
    - FDE: support passphrase quality check at runtime via the
      /v2/system-volumes endpoint
    - FDE: update secboot to revision 3e181c8edf0f
    - Confdb: support lists and indexed paths on read and write
    - Confdb: alias references must be wrapped in brackets
    - Confdb: support indexed paths in confdb-schema assertion
    - Confdb: make API errors consistent with options
    - Confdb: fetch confdb-schema assertion on access
    - Confdb: prevent --previous from being used in read-side hooks
    - Components: fix snap command with multiple components
    - Components: set revision of seed components to x1
    - Components: unmount extra kernel-modules components mounts
    - AppArmor Prompting: add lifespan "session" for prompting rules
    - AppArmor Prompting: support restoring prompts after snapd restart
    - AppArmor Prompting: limit the extra information included in probed
      AppArmor features and system key
    - Notices: refactor notice state internals
    - SELinux: look for restorecon/matchpathcon at all known locations
      rather than current PATH
    - SELinux: update policy to allow watching cgroups (for RAA), and
      talking to user session agents (service mgmt/refresh)
    - Refresh App Awareness: Fix unexpected inotify file descriptor
      cleanup
    - snap-confine: workaround for glibc fchmodat() fallback and handle
      ENOSYS
    - snap-confine: add support for host policy for limiting users able
      to run snaps
    - LP: #2114923 Reject system key mismatch advise when not yet seeded
    - Use separate lanes for essential and non-essential snaps during
      seeding and allow non-essential installs to retry
    - Fix bug preventing remodel from core18 to core18 when snapd snap
      is unchanged
    - LP: #2112551 Make removal of last active revision of a snap equal
      to snap remove
    - LP: #2114779 Allow non-gpt in fallback mode to support RPi
    - Switch from using systemd LogNamespace to manually controlled
      journal quotas
    - Change snap command trace logging to only log the command names
    - Grant desktop-launch access to /v2/snaps
    - Update code for creating the snap journal stream
    - Switch from using core to snapd snap for snap debug connectivity
    - LP: #2112544 Fix offline remodel case where we switched to a
      channel without an actual refresh
    - LP: #2112332 Exclude snap/snapd/preseeding when generating preseed
      tarball
    - LP: #1952500 Fix snap command progress reporting
    - LP: #1849346 Interfaces: kerberos-tickets |  add new interface
    - Interfaces: u2f | add support for Thetis Pro
    - Interfaces: u2f | add OneSpan device and fix older device
    - Interfaces: pipewire, audio-playback | support pipewire as system
      daemon
    - Interfaces: gpg-keys | allow access to GPG agent sockets
    - Interfaces: usb-gadget | add new interface
    - Interfaces: snap-fde-control, firmware-updater-support | add new
      interfaces to support FDE
    - Interfaces: timezone-control | extend to support timedatectl
      varlink
    - Interfaces: cpu-control | fix rules for accessing IRQ sysfs and
      procfs directories
    - Interfaces: microstack-support | allow SR-IOV attachments
    - Interfaces: modify AppArmor template to allow snaps to read their
      own systemd credentials
    - Interfaces: posix-mq | allow stat on /dev/mqueue
    - LP: #2098780 Interfaces: log-observe | add capability
      dac_read_search
    - Interfaces: block-devices | allow access to ZFS pools and datasets
    - LP: #2033883 Interfaces: block-devices | opt-in access to
      individual partitions
    - Interfaces: accel | add new interface to support accel kernel
      subsystem
    - Interfaces: shutdown | allow client to bind on its side of dbus
      socket
    - Interfaces: modify seccomp template to allow pwritev2
    - Interfaces: modify AppArmor template to allow reading
      /proc/sys/fs/nr_open
    - Packaging: drop snap.failure service for openSUSE
    - Packaging: add SELinux support for openSUSE
    - Packaging: disable optee when using nooptee build tag
    - Packaging: add support for static PIE builds in snapd.mk, drop
      pie.patch from openSUSE
    - Packaging: add libcap2-bin runtime dependency for ubuntu-16.04
    - Packaging: use snapd.mk for packaging on Fedora
    - Packaging: exclude .git directory
    - Packaging: fix DPKG_PARSECHANGELOG assignment


=== debian/control ===
--- 
+++ 
@@ -2,8 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Michael Hudson-Doyle <mwhudson@debian.org>
-Uploaders: Zygmunt Krynicki <me@zygoon.pl>,
-           Michael Vogt <mvo@debian.org>
+Uploaders: Zygmunt Krynicki <me@zygoon.pl>, Michael Vogt <mvo@debian.org>
 Build-Depends: debhelper (>= 13),
                debhelper-compat (= 13),
                dh-apparmor,
@@ -16,7 +15,6 @@
                dbus,
                fakeroot,
                gcc-i686-linux-gnu [amd64] <!nocheck>,
-               libc6-dev-i386-cross [amd64] <!nocheck>,
                gettext,
                gnupg2,
                golang-dbus-dev,
@@ -27,7 +25,9 @@
                golang-github-jessevdk-go-flags-dev,
                golang-github-juju-ratelimit-dev,
                golang-github-kr-pretty-dev,
+               golang-github-mattn-go-runewidth-dev,
                golang-github-mvo5-goconfigparser-dev,
+               golang-github-rivo-uniseg-dev,
                golang-github-seccomp-libseccomp-golang-dev,
                golang-go (>=2:1.18),
                golang-golang-x-crypto-dev,
@@ -43,6 +43,8 @@
                grub-common,
                indent,
                libapparmor-dev,
+               libblkid-dev,
+               libc6-dev-i386-cross [amd64] <!nocheck>,
                libcap-dev,
                libglib2.0-dev,
                liblzo2-dev,
@@ -58,21 +60,26 @@
                tzdata,
                udev,
                xfslibs-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/snapcore/snapd
 Vcs-Browser: https://salsa.debian.org/debian/snapd
 Vcs-Git: https://salsa.debian.org/debian/snapd.git
 XS-Go-Import-Path: github.com/snapcore/snapd
 
 Package: golang-github-snapcore-snapd-dev
+Section: golang
 Architecture: all
 Breaks: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
         golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
 Replaces: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
           golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
 Depends: ${misc:Depends}
-Description: snappy development go packages.
- Use these to use the snappy API.
+Multi-Arch: foreign
+Description: Source code of the github.com/snapcore/snapd go module
+ This package contains the Go module for all of snapd source code.
+ A good chunk of the API is unstable and is not a guaranteed interface.
+ The client/ package is more stable and may be used by applications
+ looking to integate with the snapd REST API.
 
 Package: snapd
 Architecture: any
@@ -82,6 +89,7 @@
          default-dbus-session-bus | dbus-session-bus,
          gnupg1 | gnupg,
          kmod,
+         libcap2-bin,
          openssh-client,
          squashfs-tools,
          systemd,
@@ -93,15 +101,16 @@
           ubuntu-core-launcher (<< 2.22),
           ubuntu-snappy (<< 1.9),
           ubuntu-snappy-cli (<< 1.9)
-Breaks: snap-confine (<< 2.23),
+Breaks: snap (<< 2013-11-29),
+        snap-confine (<< 2.23),
         snapd-xdg-open (<= 0.0.0),
         ubuntu-core-launcher (<< 2.22),
         ubuntu-snappy (<< 1.9),
         ubuntu-snappy-cli (<< 1.9),
         ${snapd:Breaks}
+Static-Built-Using: ${misc:Static-Built-Using}
 Recommends: gnupg
 Suggests: zenity | kdialog
-Conflicts: snap (<< 2013-11-29-1ubuntu1)
 Built-Using: ${Built-Using} ${misc:Built-Using}
 Description: Daemon and tooling that enable snap packages
  Install, configure, refresh and remove snap packages. Snaps are
@@ -110,18 +119,3 @@
  cloud, servers, desktops and the internet of things.
  .
  Start with 'snap list' to see installed snaps.
-
-Package: snap-confine
-Architecture: any
-Section: oldlibs
-Depends: snapd (= ${binary:Version}), ${misc:Depends}
-Description: Transitional package for snapd
- This is a transitional dummy package. It can safely be removed.
-
-Package: ubuntu-core-launcher
-Architecture: any
-Depends: snapd (= ${binary:Version}), ${misc:Depends}
-Section: oldlibs
-Pre-Depends: dpkg (>= 1.15.7.2)
-Description: Transitional package for snapd
- This is a transitional dummy package. It can safely be removed.

=== debian/rules ===
--- 
+++ 
@@ -74,7 +74,7 @@
 # check if we need to include the testkeys in the binary
 # TAGS are the go build tags for all binaries, SNAP_TAGS are for snap
 # build only.
-TAGS=nosecboot
+TAGS=nosecboot nooptee
 SNAP_TAGS=nosecboot nomanagers
 ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
 	TAGS+= withtestkeys
@@ -155,7 +155,7 @@
 	find _build/src/$(DH_GOPKG)/cmd/snap-fde-keymgr -name "*.go" | xargs rm -f
 	find _build/src/$(DH_GOPKG)/gadget/install -name "*.go" | grep -vE '(params\.go|install_dummy\.go|kernel\.go)'| xargs rm -f
 	# XXX: once dh-golang understands go build tags this would not be needed
-	find _build/src/$(DH_GOPKG)/secboot/ -name "*.go" | grep -E '(.*_sb(_test)?\.go|.*_tpm(_test)?\.go|secboot_hooks.go|keymgr/)' | xargs rm -f
+	find _build/src/$(DH_GOPKG)/secboot/ -name "*.go" | grep -E '(.*_sb(_test)?\.go|.*_tpm(_test)?\.go|secboot_hooks.go|auth_requestor.go|keymgr/)' | xargs rm -f
 	mv _build/src/$(DH_GOPKG)/secboot/keys/plainkey.go _build/src/$(DH_GOPKG)/secboot/keys/plainkey_sb.go
 	mv _build/src/$(DH_GOPKG)/secboot/keys/plainkey_test.go _build/src/$(DH_GOPKG)/secboot/keys/plainkey_sb_test.go
 	find _build/src/$(DH_GOPKG)/secboot/keys/ -name "*.go" | grep -E '(.*_sb(_test)?\.go)' | xargs rm -f
@@ -177,4 +177,3 @@
 	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. go build -tags "$(TAGS)" --ldflags '-extldflags "-static"' $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snap-update-ns)
 
 	# ensure we generated a static build
-	$(shell	if ldd _build/bin/snap-exec; then false "need static build"; fi)

=== debian/watch ===
version=4
  opts="searchmode=plain,\
  filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%" \
  https://api.github.com/repos/snapcore/snapd/releases?per_page=100 \
  https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@
